--[[
====================================================
PSP LyricShow Player 0.9.8
Ex_FileList by ʫŵ
Other codes by gadget2k@pspchina.net
====================================================
]]
rootdir = "ms0:/MUSIC/"
select=1
scroll=0
	
function browser()

	mp3file,num,id3name,id3artist,id3album=Ex_FileList(".mp3",true,rootdir)
	exit=false
	maxline=16
	while exit==false do
		pad = Controls.read()
		if pad:start() then
			System.Quit()
		
		elseif pad:up() then
			if select < 2 then 
				select = 1 
			else 
				select=select-1 
			end
			if scroll > 0 and select <= scroll then 
				scroll = scroll-1
			end

		elseif pad:left()  then
			if select < 2 then 
				select = 1 
			else
				select=select-maxline
				if select < 1 then
					select=1
				end
			end
			if (scroll > 0 and select <= scroll) then
				scroll = scroll-maxline
				if scroll < 0 then
					scroll=0
				end
			end

		elseif pad:down() then
			if select > num-1 then
				select = num
			else
				select=select+1
			end
			if select > maxline and scroll < num-maxline then
				scroll = scroll+1
			end

		elseif pad:right() then
			if select > num-maxline then
				select = num
			else
				select=select+maxline
			end
			if (select > maxline) and (scroll < num-maxline) then
				scroll = scroll+maxline
				if scroll > num-maxline then
					scroll = num-maxline
				end
			end

		elseif pad:circle() then
			if select<=num then
				PlayMp3(select)
			end
		
		elseif pad:square() then
			System.message("PSP LyricShow Player v0.9.8, made by gadget2k. Powered by LPHMv2. Thanks to Shinuobi, John and Winner74.",0)
		
		elseif pad:triangle() then
			delFile = mp3file[select]
			delLRC = string.sub(delFile,1,-4).."lrc"		
			if System.doesFileExist(delLRC)	==1 then 
				fileinfo = delFile .." and "..delLRC 
			else 
				fileinfo = delFile 
			end
			System.message("Are you sure to delete these music files?\n"..fileinfo,1)
			if System.buttonPressed() == 1 then
				System.currentDirectory(rootdir)
				System.removeFile(delFile)						
				if System.doesFileExist(delLRC)	==1 then System.removeFile(delLRC) end
				select=1
				scroll=0
				browser()
			end	
		end
	    

		screen.clear(black)
		screen.startDraw()
		Image.blit(0,0,bg1)		
		for i=1,num do	
			if i-scroll <= maxline and i-scroll > 0 then
				if i==select then Image.fillRect(8, 13*(i-scroll)+28,470,13*(i-scroll)+40,barcolor) end
				zhPrint(10, 13*(i-scroll)+28, string.format("%03d",i))
				if #id3name[i] > 32 then 
					mp3name=string.sub(id3name[i],1,28).."...."
				else
					mp3name=id3name[i]
				end
				if #id3artist[i]>30 then
					mp3artist=string.sub(id3artist[i],1,26).."...."
				else
					mp3artist=id3artist[i]
				end
				filesize_n=string.format("%3d",System.getFileSize(mp3file[i])/1024/1024)
				filesize=string.format("%s%s",filesize_n," MB")
				zhPrint(40, 13*(i-scroll)+28, mp3name)
				zhPrint(250, 13*(i-scroll)+28, mp3artist)				
				zhPrint(420, 13*(i-scroll)+28, filesize)				
			end
		end
		getBattTime()
		zhPrint(10, 20, ""..num.."")
		zhPrint(290, 20, sysDate)
		zhPrint(350, 20, sysTime)
		zhPrint(410, 20, "" .. Battery)
		zhPrint(10, 256, "  |  ʮ |  ɾ |   | START ˳")
		screen.endDraw()
		screen.flipscreen()
		screen.waitVblankStart()
	end
	return false
end

function Ex_FileList(ext,child,path) -- ʫŵֵstdio.lua
	ext=string.lower(ext)
	local n,len=0,-string.len(ext)
	local bak=System.currentDirectory(path or "")
	local root,mp3file,id3name,id3artist,id3album=System.listDirectory(),{},{},{},{}
	table.remove(root,1)
	table.remove(root,1)
	for i,cur in ipairs(root) do
		if cur.directory then
			if child then
				local lst=System.listDirectory(cur.name)
				for j,tmp in ipairs(lst) do
					if ext==string.lower(string.sub(tmp.name,len)) then
						n=n+1;mp3file[n]=string.format("%s%s%s",cur.name,"/",tmp.name)					
						tags=getTag(mp3file[n])
						id3name[n]=tags.name
						id3artist[n]=tags.artist
						id3album[n]=tags.album
					end
				end
			end
		elseif ext==string.lower(string.sub(cur.name,len)) then
			n=n+1;mp3file[n]=cur.name;
			tags=getTag(mp3file[n])
			id3name[n]=tags.name
			id3artist[n]=tags.artist
			id3album[n]=tags.album
		end		
		
	end
	System.currentDirectory(bak)
	return mp3file,n,id3name,id3artist,id3album
end
